Unit afg7z_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure afg7z(NM :Integer; N :Integer; LOW :Integer; IGH :Integer;
                var AR :Array of Extended; var AI :Array of Extended;
                var ORTR :Array of Extended; var ORTI :Array of Extended);

implementation

procedure afg7z(NM :Integer; N :Integer; LOW :Integer; IGH :Integer;
                var AR :Array of Extended; var AI :Array of Extended;
                var ORTR :Array of Extended; var ORTI :Array of Extended);
var
I,II,J,JJ,KP1,LA,M,MP :Integer;
F,FI,FR,G,H,SCALE :Extended;
const
SYS056 :Extended = 5.56268464627e-308;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140;
begin
LA := IGH - 1;
KP1 := LOW + 1;
if ( LA <  KP1 ) 
 then goto _140;
for M:=KP1 to LA do
 begin
  H := 0.0e0;
  ORTR[M-1] := 0.0e0;
  ORTI[M-1] := 0.0e0;
  SCALE := 0.0e0;
{  HOPMPOBKA CTOA }
  for I:=M to IGH do
   begin
    SCALE := SCALE + Abs(AR[(I-1)+(M-2)*NM]) + Abs(AI[(I-1)+(M-2)*NM]);
_10:
   end;
  if ( SCALE >  SYS056 ) 
   then goto _30;
  for I:=M to IGH do
   begin
    AR[(I-1)+(M-2)*NM] := 0.e0;
    AI[(I-1)+(M-2)*NM] := 0.e0;
_20:
   end;
  goto _130;
_30:
  MP := M + IGH;
  F := 1.e0/SCALE;
{   I = IGH,M,-1 }
  for II:=M to IGH do
   begin
    I := MP - II;
    ORTR[I-1] := AR[(I-1)+(M-2)*NM]*F;
    ORTI[I-1] := AI[(I-1)+(M-2)*NM]*F;
    H := H + ORTR[I-1]*ORTR[I-1] + ORTI[I-1]*ORTI[I-1];
_40:
   end;
  G := Sqrt(H);
  F := EMax1(Abs(ORTR[M-1]),Abs(ORTI[M-1]));
  if ( F <=  SYS056 ) 
   then goto _50;
  FR := ORTR[M-1]/F;
  FI := ORTI[M-1]/F;
  F := Sqrt(FR*FR+FI*FI)*F;
  H := H + F*G;
  G := G/F;
  ORTR[M-1] := (1.0e0 + G)*ORTR[M-1];
  ORTI[M-1] := (1.0e0 + G)*ORTI[M-1];
  goto _60;
_50:
  ORTR[M-1] := G;
  ORTI[M-1] := 0.0e0;
  AI[(M-1)+(M-2)*NM] := 0.0e0;
  AR[(M-1)+(M-2)*NM] := SCALE;
{  OPM-E (I-(U*UH)/H)*A }
_60:
  for J:=M to N do
   begin
    FR := 0.0e0;
    FI := 0.0e0;
{   I = IGH,M,-1 }
    for II:=M to IGH do
     begin
      I := MP - II;
      FR := FR + ORTR[I-1]*AR[(I-1)+(J-1)*NM] + ORTI[I-1]*AI[(I-1)+(J-1)*NM];
      FI := FI + ORTR[I-1]*AI[(I-1)+(J-1)*NM] - ORTI[I-1]*AR[(I-1)+(J-1)*NM];
_70:
     end;
    FR := FR/H;
    FI := FI/H;
    for I:=M to IGH do
     begin
      AR[(I-1)+(J-1)*NM] := AR[(I-1)+(J-1)*NM] - FR*ORTR[I-1] + FI*ORTI[I-1];
      AI[(I-1)+(J-1)*NM] := AI[(I-1)+(J-1)*NM] - FR*ORTI[I-1] - FI*ORTR[I-1];
_80:
     end;
_90:
   end;
{   OPM-E (I-(U*UH)/H)*A*(I-(U*UH)/H) }
  for I:=1 to IGH do
   begin
    FR := 0.0e0;
    FI := 0.0e0;
{   J = IGH,M,-1 }
    for JJ:=M to IGH do
     begin
      J := MP - JJ;
      FR := FR + ORTR[J-1]*AR[(I-1)+(J-1)*NM] - ORTI[J-1]*AI[(I-1)+(J-1)*NM];
      FI := FI + ORTR[J-1]*AI[(I-1)+(J-1)*NM] + ORTI[J-1]*AR[(I-1)+(J-1)*NM];
_100:
     end;
    FR := FR/H;
    FI := FI/H;
    for J:=M to IGH do
     begin
      AR[(I-1)+(J-1)*NM] := AR[(I-1)+(J-1)*NM] - FR*ORTR[J-1] - FI*ORTI[J-1];
      AI[(I-1)+(J-1)*NM] := AI[(I-1)+(J-1)*NM] + FR*ORTI[J-1] - FI*ORTR[J-1];
_110:
     end;
_120:
   end;
  ORTR[M-1] := SCALE*ORTR[M-1];
  ORTI[M-1] := SCALE*ORTI[M-1];
  AR[(M-1)+(M-2)*NM] := -G*AR[(M-1)+(M-2)*NM];
  AI[(M-1)+(M-2)*NM] := -G*AI[(M-1)+(M-2)*NM];
_130:
 end;
_140:
end;

end.
